<?php

/**
 * inf_estado_cm actions.
 *
 * @package    controlComisiones
 * @subpackage inf_estado_cm
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_estado_cmActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.fecha_pago, tab0.no_pago ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $id_anhos = $request['id_anhos'];
            $id_proyecto = $request['id_proyecto'];
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];


            /*
             * Variables opcionales
             */
            $whereComisionado = "";
            if (isset($request['id_tercero'])) {
                $whereComisionado = " AND tab0.id_tercero = " . $request['id_tercero'];
            }
            $whereNoPago = "";
            if (isset($request['no_pago'])) {
                $whereNoPago = " AND tab0.no_pago = " . $request['no_pago'];
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);
            

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select tab0.*

from(

    select 
    tab0.observaciones,
    tab0.estado,tab3.id_proyecto,tab0.ID_ANHOS,
    tab7.id_tercero,
    tab7.NUM_DOC,
    tab7.NOMBRE, tab0.no_pago,
    tab0.fecha_pago,NVL(tab0.valor_neto,0) EJECUTADO,
    tab5.ASIGNADO,tab5.SALDO,
    tab5.EJECUTADO_CM,tab5.REEMBOLSO,tab6.descripcion
    
    from COM_PAGO_EGRESO tab0
    join COM_CUENTA_V tab1 ON tab1.id_cuenta = tab0.id_cuenta
    join COM_RESOLUCION tab2 ON tab2.ID_RESOLUCION = tab1.ID_RESOLUCION
    join COM_COMISION tab3 ON tab3.ID_COMISION = tab2.ID_COMISION
    
    LEFT JOIN(
        select tab0.ID_PAGO_EGRESO,sum(nvl(tab0.VR_NETO,0)) VALOR
        from COM_REGISTRO_GASTO tab0
        group by tab0.ID_PAGO_EGRESO    
    )tab4 ON tab4.ID_PAGO_EGRESO = tab0.id_pago_egreso
    
    JOIN COM_TERCERO tab7 ON tab7.id_tercero = tab1.id_tercero
    
    left join(
      select 
      tab0.ID_PROYECTO, tab0.id_anhos,
      sum(tab0.valor) AS ASIGNADO,
      sum(tab0.saldo) AS SALDO,
      sum(tab0.VALOR_PAGO) EJECUTADO_CM,
      sum(tab0.valor_reintegro) valor_reintegro,
      sum(tab0.VALOR_REEMBOLSO) REEMBOLSO    
      from COM_SALDO_PRESUP tab0    
      group by 
      TAB0.ID_PROYECTO, tab0.id_anhos  
    )tab5 ON tab5.ID_PROYECTO = tab3.ID_PROYECTO and tab5.id_anhos = tab0.id_anhos
    
    join PROYECTOS tab6 ON tab6.id = tab3.ID_PROYECTO

)tab0

where 
tab0.id_anhos = $id_anhos and tab0.ID_PROYECTO = $id_proyecto 
and tab0.estado = 1
and tab0.fecha_pago between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
$whereComisionado $whereNoPago                     
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select tab0.*

from(

    select 
    tab0.observaciones,
    tab0.estado,tab3.id_proyecto,tab0.ID_ANHOS,
    tab7.id_tercero,
    tab7.NUM_DOC,
    tab7.NOMBRE, tab0.no_pago,
    tab0.fecha_pago,NVL(tab0.valor_neto,0) EJECUTADO,
    tab5.ASIGNADO,tab5.SALDO,
    tab5.EJECUTADO_CM,tab5.REEMBOLSO,tab6.descripcion
    
    from COM_PAGO_EGRESO tab0
    join COM_CUENTA_V tab1 ON tab1.id_cuenta = tab0.id_cuenta
    join COM_RESOLUCION tab2 ON tab2.ID_RESOLUCION = tab1.ID_RESOLUCION
    join COM_COMISION tab3 ON tab3.ID_COMISION = tab2.ID_COMISION
    
    LEFT JOIN(
        select tab0.ID_PAGO_EGRESO,sum(nvl(tab0.VR_NETO,0)) VALOR
        from COM_REGISTRO_GASTO tab0
        group by tab0.ID_PAGO_EGRESO    
    )tab4 ON tab4.ID_PAGO_EGRESO = tab0.id_pago_egreso
    
    JOIN COM_TERCERO tab7 ON tab7.id_tercero = tab1.id_tercero
    
    left join(
      select 
      tab0.ID_PROYECTO, tab0.id_anhos,
      sum(tab0.valor) AS ASIGNADO,
      sum(tab0.saldo) AS SALDO,
      sum(tab0.VALOR_PAGO) EJECUTADO_CM,
      sum(tab0.valor_reintegro) valor_reintegro,
      sum(tab0.VALOR_REEMBOLSO) REEMBOLSO    
      from COM_SALDO_PRESUP tab0    
      group by 
      TAB0.ID_PROYECTO, tab0.id_anhos  
    )tab5 ON tab5.ID_PROYECTO = tab3.ID_PROYECTO and tab5.id_anhos = tab0.id_anhos
    
    join PROYECTOS tab6 ON tab6.id = tab3.ID_PROYECTO

)tab0

where 
tab0.id_anhos = $id_anhos and tab0.ID_PROYECTO = $id_proyecto 
and tab0.estado = 1
and tab0.fecha_pago between to_date( '$fecha_ini' , 'yyyy-mm-dd' ) and to_date( '$fecha_fin' , 'yyyy-mm-dd' )
$whereComisionado $whereNoPago     

$sortBy   
   
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_estado_cm] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
